/*jslint nomen: true*/
/*global Ext Zarafa _ odf document*/
Ext.namespace('Zarafa.plugins');

Zarafa.plugins.OdfDialog = Ext.extend(Zarafa.core.ui.Dialog, {
	/**
	 * @cfg {string} URL from where to load the ODF file
	 */
	url: undefined,
	/**
	 * @constructor
	 * @param config Configuration structure
	 */
	constructor : function (config) {
		config = config || {};

		config = Ext.applyIf(config, {
			// Override from Ext.Component
			xtype : 'zarafa.odfdialog',
			layout: 'fit',
			title: config.name,
			border: false,
			items: [{
				xtype: 'panel',
				border: false,
				layout: 'vbox',
				items: [{
					xtype	: 'button', 
					text	: _('Download'),
					handler: function () { this.onDownload(config.url); },
					scope	: this
				}, {
					xtype	: 'box', 
					scope	: this,
					autoEl: {
						tag: 'div',
						frameBorder: 0,
						style: {border: '0 none'}
					},
					autoScroll: true,
					scroll: true,
					id      : 'webodf'
				}]
			}],
			listeners : {
				afterrender : this.onAfterRender,
				scope: this
			}
		});

		this.odfurl = config.url;

		Ext.apply(this, config);

		Zarafa.plugins.OdfDialog.superclass.constructor.call(this, config);
	},
	onAfterRender : function () {
		var cmp = Ext.getCmp('webodf');
		if (cmp && cmp.el && cmp.el.dom) {
			this.odfcanvas = new odf.OdfCanvas(cmp.el.dom);
			this.odfcanvas.load(this.odfurl);
		}
	},
	onDownload : function (url) {
		// reuse the frame from AttachementLinks
		var iframe = document.getElementById(
			'zarafa-attachment-iframedownload');
		// Set the hidden iframe to make the browser save/open file
		iframe.contentWindow.location = url;
	}
});

Zarafa.core.ui.Dialog.register(Zarafa.plugins.OdfDialog, 'zarafa.odfdialog');
